 %LoadFromMatFile.m
 
 function LoadFromMatFile
global MSpScnList MSpf MSpScn
persistent LocalDir
 
f0=figure('Visible','off',...
	'MenuBar', 'none', ...
	'CloseRequestFcn',{@closeIt},...
'Position',[400,400,500,150]);
set(f0,'Name','MatSpec: Load from Mat-file');
set(f0,'tag','LoadFromMatFile');
set(f0,'Visible','on');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');

hLbMatFileName = uicontrol('Style','text','String',...
	'Mat File to load:','Position',[25,100,100,25]);
hEdMatFileName = uicontrol('Style','edit','String',...
	'MSpScanLiquid.mat','Position',[125,100,250,25]);
hBtMatFileName=uicontrol('Style','pushbutton','String',...
	'Browse','Position',[375,100,100,25],...
	'Callback',{@matFileName_Callback});

hBtLoad=uicontrol('Style','pushbutton','String','Load',...
	'Position',[200,50,80,25],'Callback',{@load_Callback});


function matFileName_Callback(hObject,eventdata)
    
if isempty(LocalDir),
 LocalDir='';
end;
if isempty(LocalDir),
  mypath='./*.mat';
else
    mypath=[LocalDir,'*.mat'];
end;
[file,mypath]=uigetfile(mypath);
LocalDir=mypath;

set(hEdMatFileName,'String',[mypath,file]);

end


function load_Callback(hObject,eventdata)
%	cmd='';
%	PrintFormat='eps';
%	PrintExt='eps';
	FName=get(hEdMatFileName,'String');
	if strcmp(FName(end-3:end),'mat'),
					FName=[FName,'.mat'];
	end;
	if ~exist(FName,'file'),
			error('Can not find file %s\n',FName);
	end;        
	% Get the name of the variable in Matfile
	scn=who('-file',FName);
	if length(scn)~=1,
		msgbox(['Error: The file probably does not contain data from ',...
		 'MatSpec']);
		return;
	end;
	scn=scn{1};
	cmd=['global ',scn]; 
	eval(cmd)

	load(FName);
	if ~any(strcmp(MSpScnList,scn)),
		n=length(MSpScnList);
	MSpScnList{n+1}=scn;
	end;
	MSpScn=scn;
	hThisFig=findobj('tag','LoadFromMatFile');
	set(hndMainGUI,'Visible','On');
	close(hThisFig);
end

function closeIt(gcbf,ar2);
set(hndMainGUI,'Visible','On');
delete(f0);
end;

end
 
 
 

