function fig_hdl = MSpGUIAbout
% MatSpec GUI
% J. Novak
% build: generate_m_file('GUID_Figures\MSpGUIAbout.fig','./');
% MSPGUIABOUT_BUILD
%-------------------------------------------------------------------------------
% File name   : MSpGUIAbout_build.m           
% Generated on: 07-Jan-2009 11:09:28          
% Description :
%-------------------------------------------------------------------------------

% --- VARIABLES ----------------------------------
global MSpScnList MSpf  MSpScn;
persistent valPopExportToASCIIDatasetToHandle
persistent valListVariablesToSave
persistent strEditFilenameRoot TargetDirectory
persistent figPositon

if isempty(figPositon),
	figPositon=[520 479 462 321];
end;

fig_hdl=findobj('tag','figExportASCII');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');
if isempty(fig_hdl),
% --- FIGURE -------------------------------------
handles.figMSpGUIAbout = figure(	'Tag', 'figMSpGUIAbout', ...
	'Units', 'pixels', ...
	'Position', figPositon, ...
	'Name', 'MatSpec: About', ...
	'MenuBar', 'none', ...
	'Visible','Off',...
	'NumberTitle', 'off', ...
	'Color', get(0,'DefaultUicontrolBackgroundColor'));

% --- STATIC TEXTS -------------------------------------
handles.txtTitleAboutMatSpec = uicontrol(	'Parent', handles.figMSpGUIAbout, ...
	'Tag', 'txtTitleAboutMatSpec', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [129 282 239 30], ...
	'FontSize', 14, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'About MatSpec ');

handles.txtDescriptionTxt = uicontrol(	'Parent', handles.figMSpGUIAbout, ...
	'Tag', 'txtDescriptionTxt', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [89 220 366 51], ...
	'FontSize', 10, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', {'An utility for 2D imaging and handling of X-ray data',...
	'acquired via SPEC software from a linear',...
	'position-sensitive detector.'}, ...
	'HorizontalAlignment', 'left');

handles.txtAuthors = uicontrol(	'Parent', handles.figMSpGUIAbout, ...
	'Tag', 'txtAuthors', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [8 158 79 21], ...
	'FontSize', 10, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Author', ...
	'HorizontalAlignment', 'left');

handles.txtAuthorsTxt = uicontrol(	'Parent', handles.figMSpGUIAbout, ...
	'Tag', 'txtAuthorsTxt', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [89 130 366 80], ...
	'FontSize', 10, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', {'Jiri Novak (novak@esrf.fr)','ID10B beamline', ...
	'European synchrotron radiation facility','Grenoble, France '});

handles.txtLicence = uicontrol(	'Parent', handles.figMSpGUIAbout, ...
	'Tag', 'txtLicence', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [8 81.0000000000001 79 21], ...
	'FontSize', 10, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Licence', ...
	'HorizontalAlignment', 'left');

handles.txtLicenceTxt = uicontrol(	'Parent', handles.figMSpGUIAbout, ...
	'Tag', 'txtLicenceTxt', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [89 46 366 75], ...
	'FontSize', 10, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', {'Free software distributed under GNU licence, see','http://www.gnu.org/licenses/.','This program comes with ABSOLUTELY NO WARRANTY.'});

handles.txtDescription = uicontrol(	'Parent', handles.figMSpGUIAbout, ...
	'Tag', 'txtDescription', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [8 235 79 21], ...
	'FontSize', 10, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Description', ...
	'HorizontalAlignment', 'left');

% --- PUSHBUTTONS -------------------------------------
handles.btnOK = uicontrol(	'Parent', handles.figMSpGUIAbout, ...
	'Tag', 'btnOK', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'pixels', ...
	'Position', [204 11 83 26], ...
	'FontSize', 10, ...
	'FontWeight', 'bold', ...
	'String', 'OK', ...
	'Callback', @btnOK_Callback);

% Save handles structure
guidata(handles.figMSpGUIAbout,handles);

% Assign function output
fig_hdl = handles.figMSpGUIAbout;

movegui(fig_hdl,'center');
set(fig_hdl,'visible','on');
else
figure(fig_hdl);
end;

%-------------------------------------------------------------------------------
	function btnOK_Callback(hObject,evendata)
		figPositon=get(handles.figMSpGUIAbout,'Position');
		set(hndMainGUI,'Visible','On');
		close(fig_hdl);
	end

end
