%% MSpPlotGrid2.m
function MSpPlotGrid(si,xField,yField,colorField,flgLog,AxFontSize,LabelFontSize,truncTop,truncBot);
% Plots data grided in reciprocal space in 2D
% si .. structure with the measured data
% xField .. which field comes on x-axis
% yField .. which field comes on y-axis
% colorField .. which field comes on z-axis (is colorscaled)
% flgLog .. plot z axis on logarithmic scale yes/no
% (c) 2007, Jiri Novak, ESRF Grenoble, France 
%%%%
% This program comes with ABSOLUTELY NO WARRANTY.  This is free
% software distributed under GNU licence, see
% http://www.gnu.org/licenses/ or the attached file GPLicense.txt



zAx=si.(colorField);
x=si.(xField);
y=si.(yField);
if flgLog==1,
	ind=find(zAx<=0);
	indc=find(zAx>0);
	zAx(ind)=min(zAx(indc))/0.4;
	if (nargin<8 | (truncTop==0 & truncBot==0))
		truncTop=0;
		truncBot=max(max(log10(zAx)))-min(min(log10(zAx)));
	end;
end;
[nn,mm]=size(zAx);
if flgLog==1,
	imagesc(x,y,MSpMaplog2(zAx,truncBot,truncTop)); axis xy;
	hndColBar=colorbar;
	set(get(hndColBar,'ylabel'),'string',...
		'log_{10} (Intensity) (Arb. Unit.)','fontsize',LabelFontSize);
else
	imagesc(x,y,zAx); axis xy;
	hndColBar=colorbar;
	set(get(hndColBar,'ylabel'),'string',...
		'Intensity (Arb. Unit.)','fontsize',LabelFontSize);
end;
if strcmp(xField,'Qxg'),
	mylabel='Q_x (A^{-1})';
elseif strcmp(xField,'Qyg'),
	mylabel='Q_y (A^{-1})';
elseif strcmp(xField,'Qzg'),
	mylabel='Q_z (A^{-1})';
end;
xlabel(mylabel,'interpreter','tex','fontsize',LabelFontSize);
if strcmp(yField,'Qxg'),
	mylabel='Q_x (A^{-1})';
elseif strcmp(yField,'Qyg'),
	mylabel='Q_y (A^{-1})';
elseif strcmp(yField,'Qzg'),
	mylabel='Q_z (A^{-1})';
end;
ylabel(mylabel,'interpreter','tex','fontsize',LabelFontSize);
set(gca,'fontsize',AxFontSize);
set(hndColBar,'fontsize',AxFontSize);
hndXL=get(gca,'xlabel');
pos=get(hndXL,'position');
set(hndXL,'position',pos.*[1 1.03 1]);
