%% MSpPlotPSD2.m
% function MSpPlotPSD2(si,xField,PSDField,flgLog,varargin);
% varargin ... pairs of variablename, value
%  'truncLogTop', 'truncLogBot' to truncate logarithmic
% (c) 2007, Jiri Novak, ESRF Grenoble, France 
%%%%
% This program comes with ABSOLUTELY NO WARRANTY.  This is free
% software distributed under GNU licence, see
% http://www.gnu.org/licenses/ or the attached file GPLicense.txt



function MSpPlotPSD2(si,xField,PSDField,flgLog,varargin);
if nargin>4,
	inarg=cell2struct(varargin(2:2:end),varargin(1:2:end),2);
end;
x=si.(xField);
y=si.channs;
z=si.(PSDField);
if flgLog==1,
	ind=find(z<=0);
	indc=find(z>0);
	z(ind)=min(z(indc))/10;
	if exist('inarg','var'),
		if isfield(inarg,'truncLogTop'),
			truncLogTop=inarg.truncLogTop;
		else
			truncLogTop=0;
		end;
		if isfield(inarg,'truncLogBot'),
			truncLogBot=inarg.truncLogBot;
		else
			truncLogBot=0;
		end;
	else
		truncLogTop=0;
		truncLogBot=0;
	end;
	if (truncLogTop==0 & truncLogBot==0)
		truncLogTop=0;
		truncLogBot=max(max(log10(z)))-min(min(log10(z)));
	end;
	z=MSpMaplog2(z,truncLogBot,truncLogTop);
end;

[x,ind]=sort(x);
z=z(ind,:);
delx=diff(x);
ind=find(delx==0);
if ~isempty(ind),
	x(ind)=[];
	z(ind,:)=[];
end;
delx=diff(x);
mi=min(delx); ma=max(delx);
if (mi~=ma),
	delx=mean(delx);
	xi=[min(x):delx:max(x)]';
	zi=zeros(length(xi),length(y));
	for ii=1:length(y),
		zi(:,ii)=interp1(x,z(:,ii),xi);
	end;
	imagesc(xi,y,zi');
else
	imagesc(x,y,z');
end;
set(gca,'tag','PSDRoughPlot');
axis xy;
if flgLog==1,
	hndColBar=colorbar;
	set(get(hndColBar,'ylabel'),'string',...
		'log_{10} (Intensity) (Arb. Unit.)');
else
	hndColBar=colorbar;
	set(get(hndColBar,'ylabel'),'string',...
		'Intensity (Arb. Unit.)');
end;
xlabel(xField);
ylabel('PSD pixels ()');
