%GUIMatSpec.m

function GUIMatSpec

global MSpf MSpScnList MSpScn
f=figure('Visible','off','Position',[300,300,525,300],...
	'MenuBar', 'none', ...
	'Name','MatSpec: Main menu',...
	'Tag','figGUIMatSpec',...
	'CloseRequestFcn',{@closeIt});

hLoadFromSpec=uicontrol('Style','pushbutton','String',...
	'Load from SPEC','Position',[50,250,125,25],...
	'Callback',{@loadFromSpec_Callback});
set(hLoadFromSpec, 'TooltipString','Load data from a SPEC file');
hLoadFromMatFile=uicontrol('Style','pushbutton','String',...
	'Load from MAT-file','Position',[50,200,125,25],...
	'Callback',{@loadFromMatFile_Callback});
hNormalizeIntensities=uicontrol('Style','pushbutton','String',...
	'Normalize intensities','Position',[50,150,125,25],...
	'Callback',{@normalizeIntensities_Callback});
hPlotRoughData=uicontrol('Style','pushbutton','String',...
	'Plot rough data','Position',[50,100,125,25],...
	'Callback',{@plotRoughData_Callback});

hTransform2QSpace=uicontrol('Style','pushbutton','String',...
'Transform to Q-space','Position',[200,250,125,25],...
'Callback',{@transform2QSpace_Callback});
hGridData=uicontrol('Style','pushbutton','String','Map to grid',...
'Position',[200,200,125,25],'Callback',{@griddata_Callback});
hPlotData=uicontrol('Style','pushbutton','String',...
	'Plot data','Position',[200,150,125,25],...
	'Callback',{@plotData_Callback});

hSave2MatFile=uicontrol('Style','pushbutton','String',...
	'Save to MAT-File','Position',[350,250,125,25],...
	'Callback',{@save2MatFile_Callback});
hExport2Ascii=uicontrol('Style','pushbutton','String',...
'Export to ASCII','Position',[350,200,125,25],'Callback',...
{@export2Ascii_Callback});
hAbout=uicontrol('Style','pushbutton','String',...
	'About','Position',[350,150,125,25],...
	'Callback',{@about_Callback});

movegui(f,'center');
set(f,'Visible','on');


function loadFromSpec_Callback(source, eventdata)
	LoadFromSpec;
end

function loadFromMatFile_Callback(source, eventdata)
    LoadFromMatFile;
end

function normalizeIntensities_Callback(source, eventdata)
    NormalizeIntensities;
end

function plotRoughData_Callback(source, eventdata)
    PlotRoughData;
end

function transform2QSpace_Callback(source, eventdata)
    Transform2QSpace;
end

function griddata_Callback(source, eventdata)
	GridData;
end

function plotData_Callback(source, eventdata)
	PlotData;
end

function save2MatFile_Callback(source, eventdata),
	SaveToMatFile;
end

function export2Ascii_Callback(source, eventdata)
	SaveToASCII;
end

function about_Callback(source, event),
	MSpGUIAbout;
end;

function closeIt(source, eventdata)
selection = questdlg('Do you want to close the GUI?',...
'Close Request Function', 'Yes','No','Yes');
switch selection,
   case 'Yes',
      delete(allchild(0));
      clear global MSpf MSpScnList MSpScn
   case 'No'
      return
end
end


end



