function fig_hdl = PlotData
% MatSpec GUI
% J. Novak, 08-11-04
% build: generate_m_file('PlotData.fig','../')
% PLOTDATA_BUILD
%-------------------------------------------------------------------------------
% File name   : PlotData_build.m              
% Generated on: 04-Nov-2008 12:14:53          
% Description :
%-------------------------------------------------------------------------------

% --- VARIABLES ----------------------------------
global MSpScnList MSpf  MSpScn;
persistent valPopAxis1 valPopAxis2 valPopAxis3
persistent valPopFileFormat 
persistent strLabelAxis1 strLabelAxis2 strLabelAxis3
persistent strMinPlot strMaxPlot
persistent valCheckLogAxis3
persistent valRadioPlotAs
persistent currDir

% Variables initiation
if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
			cmd=['global ', MSpScnList{ii}];
			eval(cmd);
	end;
end;

if isempty(valPopAxis1),
	valPopAxis1=1;
end;
if isempty(valPopAxis2),
	valPopAxis2=1;
end;
if isempty(valPopAxis3),
	valPopAxis3=1;
end;
if isempty(valPopFileFormat),
	valPopFileFormat=1;
end;
if isempty(strLabelAxis1),
	strLabelAxis1='Q_y (1/A)';
end;
if isempty(strLabelAxis2),
	strLabelAxis2='Q_z (1/A)';
end;
if isempty(strLabelAxis3),
	strLabelAxis3='log_{10}(Intensity) (Arb. Units)';
end;
if isempty(strMinPlot),
	strMinPlot='0.1';
end;
if isempty(strMaxPlot),
	strMaxPlot='1';
end;
if isempty(valCheckLogAxis3),
	valCheckLogAxis3=1;
end;
if isempty(valRadioPlotAs),
	valRadioPlotAs=[1,0];
end;
if isempty(currDir),
	currDir='./';
end;
PrintFormats={'eps','-depsc2';'ps','-dpsc2';'jpg','-djpeg';...
	'png','-dpng';'pdf','-dpdf'};
nameFigPlot='PlotDataPlot';
defAxFontSize=12;
defTxtFontSize=12;


fig_hdl=findobj('tag','figPlotData');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');
if isempty(fig_hdl),
% --- FIGURE -------------------------------------
handles.figPlotData = figure(	'Tag', 'figPlotData', ...
	'Units', 'characters', ...
	'Position', [103.8 24.7 100 36.6], ...
	'Name', 'MatSpec: Plot Data', ...
	'MenuBar', 'none', ...
	'Visible','Off',...
	'NumberTitle', 'off', ...
	'CloseRequestFcn',{@closeIt},...
	'Color', get(0,'DefaultUicontrolBackgroundColor'));

% Scale factor to accomodate figure for the system specific graphical properties
%htmp=uicontrol('Style','text','units','pixels',...
%	'fontunits','pixels','position',[10 10 20 10],...
%	'fontsize',10,'string','�jg');
%curH=get(htmp,'Extent');
%scalingFact=curH(4)/get(htmp,'fontsize')*0.8;
%delete(htmp);
% --- PANELS -------------------------------------
handles.uipanelAxes = uipanel(	'Parent', handles.figPlotData, ...
	'Tag', 'uipanelAxes', ...
	'UserData', zeros(1,0), ...
	'Units', 'characters', ...
	'Position', [3.1 20.5 93.5 10], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'Title', 'Axes', ...
	'TitlePosition', 'centertop');

handles.BtnGroupPlotAs = uibuttongroup(	'Parent', handles.figPlotData, ...
	'Tag', 'BtnGroupPlotAs', ...
	'UserData', [], ...
	'Units', 'characters', ...
	'Position', [23.1 5.8 56.8 4.0], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'Title', 'Plot as', ...
	'TitlePosition', 'centertop',...
	'SelectionChangeFcn',@BtnGroupPlotAs_selChangFcn);

%handles.uipanelLimitsAxis3 = uibuttongroup(	'Parent', handles.figPlotData, ...
handles.uipanelLimitsAxis3 = uipanel(	'Parent', handles.figPlotData, ...
	'Tag', 'uipanelLimitsAxis3', ...
	'UserData', [], ...
	'Units', 'characters', ...
	'Position', [3.1 10.7 50.1 9.1], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'Title', 'Limits for 3rd axis', ...
	'TitlePosition', 'centertop');

handles.uipanelSaveToFile = uipanel(	'Parent', handles.figPlotData, ...
	'Tag', 'uipanelSaveToFile', ...
	'UserData', [], ...
	'Units', 'characters', ...
	'Position', [23.1 0.6 50.1 4.2], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'Title', 'Save to file', ...
	'TitlePosition', 'centertop');

% --- PUSHBUTTONS -------------------------------------
handles.pushClose = uicontrol(	'Parent', handles.figPlotData, ...
	'Tag', 'pushClose', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [83 0.8 13.6 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Close', ...
	'Callback', @pushClose_Callback);

handles.pushPlot = uicontrol(	'Parent', handles.figPlotData, ...
	'Tag', 'pushPlot', ...
	'UserData', zeros(1,0), ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [83 5.8 13.5 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Plot', ...
	'CData', zeros(1,0), ...
	'Callback', @pushPlot_Callback);

handles.pushSave = uicontrol(	'Parent', handles.uipanelSaveToFile, ...
	'Tag', 'pushSave', ...
	'UserData', zeros(1,0), ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [33.8 0.7 15.1 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Save', ...
	'CData', zeros(1,0), ...
	'Callback', @pushSave_Callback);

% --- RADIO BUTTONS -------------------------------------
handles.radioImage = uicontrol(	'Parent', handles.BtnGroupPlotAs, ...
	'Tag', 'radioImage', ...
	'UserData', [], ...
	'Style', 'radiobutton', ...
	'Units', 'characters', ...
	'Position', [3.1 1 24.6 1.2], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', 'Image (gridded data)');

handles.radioContourPlot = uicontrol(	'Parent', handles.BtnGroupPlotAs, ...
	'Tag', 'radioContourPlot', ...
	'UserData', [], ...
	'Style', 'radiobutton', ...
	'Units', 'characters', ...
	'Position', [29.8 1 24.6 1.2], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', 'Contour plot');

% --- CHECKBOXES -------------------------------------
handles.checkLogAxis3 = uicontrol(	'Parent', handles.figPlotData, ...
	'Tag', 'checkLogAxis3', ...
	'UserData', [], ...
	'Style', 'checkbox', ...
	'Units', 'characters', ...
	'Position', [56.5 10.7 21.6 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.4 0.4 0.4], ...
	'String', 'Log scale 3rd axis', ...
	'Callback', @checkLogAxis3_Callback);

% --- EDIT TEXTS -------------------------------------
handles.editLabelAxis1 = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'editLabelAxis1', ...
	'UserData', zeros(1,0), ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [41.6 5.3 50.1 1.8], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [1 1 1], ...
	'String', 'Q_y (1/A)', ...
	'Callback', @editLabelAxis1_Callback, ...
	'CreateFcn', @editLabelAxis1_CreateFcn);

handles.editLabelAxis2 = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'editLabelAxis2', ...
	'UserData', [], ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [41.6 3.3 50.1 1.8], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [1 1 1], ...
	'String', 'Q_z (1/A)', ...
	'Callback', @editLabelAxis2_Callback, ...
	'CreateFcn', @editLabelAxis2_CreateFcn);

handles.editLabelAxis3 = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'editLabelAxis3', ...
	'UserData', [], ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [41.6 1.3 50.1 1.8], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [1 1 1], ...
	'String', 'log_10(Intensity) (Arb. Units)', ...
	'Callback', @editLabelAxis3_Callback, ...
	'CreateFcn', @editLabelAxis3_CreateFcn);

handles.editPlotMin = uicontrol(	'Parent', handles.uipanelLimitsAxis3, ...
	'Tag', 'editPlotMin', ...
	'UserData', [], ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [13.3 1.1 15 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [1 1 1], ...
	'String', '0.1', ...
	'HorizontalAlignment', 'right', ...
	'Callback', @editPlotMin_Callback, ...
	'CreateFcn', @editPlotMin_CreateFcn);

handles.editPlotMax = uicontrol(	'Parent', handles.uipanelLimitsAxis3, ...
	'Tag', 'editPlotMax', ...
	'UserData', [], ...
	'Style', 'edit', ...
	'Units', 'characters', ...
	'Position', [31 1.1 15 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [1 1 1], ...
	'String', '1', ...
	'HorizontalAlignment', 'right', ...
	'Callback', @editPlotMax_Callback, ...
	'CreateFcn', @editPlotMax_CreateFcn);

% --- POPUP MENU -------------------------------------
handles.popDatasetToHandlePlot = uicontrol(	'Parent', handles.figPlotData, ...
	'Tag', 'popDatasetToHandlePlot', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [26.5 31.5 23.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', {'Listbox'}, ...
	'Callback', @popDatasetToHandlePlot_Callback, ...
	'ButtonDownFcn', @popDatasetToHandlePlot_ButtonDownFcn, ...
	'CreateFcn', @popDatasetToHandlePlot_CreateFcn);

handles.popAxis1 = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'popAxis1', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [12.6 5.3 27 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '------', ...
	'Callback', @popAxis1_Callback, ...
	'ButtonDownFcn', @popAxis1_ButtonDownFcn, ...
	'CreateFcn', @popAxis1_CreateFcn);

handles.popAxis2 = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'popAxis2', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [12.6 3.3 27 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '------', ...
	'Callback', @popAxis2_Callback, ...
	'CreateFcn', @popAxis2_CreateFcn);

handles.popAxis3 = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'popAxis3', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [12.6 1.3 27 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '------', ...
	'Callback', @popAxis3_Callback, ...
	'CreateFcn', @popAxis3_CreateFcn);

handles.popFileFormat = uicontrol(	'Parent', handles.uipanelSaveToFile, ...
	'Tag', 'popFileFormat', ...
	'UserData', zeros(1,0), ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [12.3 0.8 16.8 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', {'eps','ps','pdf','gif','jpeg',''}, ...
	'Callback', @popFileFormat_Callback, ...
	'CreateFcn', @popFileFormat_CreateFcn);

% --- STATIC TEXTS -------------------------------------
handles.txtAxis1 = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'txtAxis1', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [1.6 5.6 9 1.2], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '1st axis', ...
	'HorizontalAlignment', 'left');

handles.txtAxis2 = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'txtAxis2', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [1.6 3.6 9 1.2], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '2nd axis', ...
	'HorizontalAlignment', 'left');

handles.txtAxis3 = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'txtAxis3', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [1.6 1.6 9 1.2], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '3rd axis', ...
	'HorizontalAlignment', 'left');

handles.txtLabels = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'txtLabels', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [55 7.5 23.5 1.0], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Axis label');

handles.txtVariables = uicontrol(	'Parent', handles.uipanelAxes, ...
	'Tag', 'txtVariables', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [14.5 7.5 23.5 1.0], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Variable');

handles.txtDatasetToHandlePlot = uicontrol(	'Parent', handles.figPlotData, ...
	'Tag', 'txtDatasetToHandlePlot', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [3.1 31.5 23.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Dataset to be handled');

handles.txtTitlePlotData = uicontrol(	'Parent', handles.figPlotData, ...
	'Tag', 'txtTitlePlotData', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [43.1 34.8 23.5 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 18, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Plot data');

handles.txtData = uicontrol(	'Parent', handles.uipanelLimitsAxis3, ...
	'Tag', 'txtData', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [0.8 3.2 12 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', 'Data');

handles.txtPlotLimits = uicontrol(	'Parent', handles.uipanelLimitsAxis3, ...
	'Tag', 'txtPlotLimits', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [0.8 1.1 12 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', 'Plot limits');

handles.txtMin = uicontrol(	'Parent', handles.uipanelLimitsAxis3, ...
	'Tag', 'txtMin', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [13.3 5.4 15 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', 'Min');

handles.txtMax = uicontrol(	'Parent', handles.uipanelLimitsAxis3, ...
	'Tag', 'txtMax', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [31 5.4 15 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', 'Max');

handles.txtMinData = uicontrol(	'Parent', handles.uipanelLimitsAxis3, ...
	'Tag', 'txtMinData', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [13.3 3.2 15 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '0.1', ...
	'HorizontalAlignment', 'right',...
	'CreateFcn',@txtMinData_CreateFcn);

handles.txtMaxData = uicontrol(	'Parent', handles.uipanelLimitsAxis3, ...
	'Tag', 'txtMaxData', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [31 3.2 15 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '1', ...
	'HorizontalAlignment', 'right',...
	'CreateFcn',@txtMaxData_CreateFcn);

handles.txtFileFormat = uicontrol(	'Parent', handles.uipanelSaveToFile, ...
	'Tag', 'txtFileFormat', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [1.3 1.0 10.6 1.2], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', 'File format', ...
	'HorizontalAlignment', 'left');


% Save handles structure
guidata(handles.figPlotData,handles);

% Tool timps
set(handles.txtAxis1,'ToolTipString','Suggested Qx, Qy or Qz');
set(handles.txtAxis2,'ToolTipString','Suggested Qx, Qy or Qz');
set(handles.txtAxis3,'ToolTipString',['Suggested PSDNormg, ',...
	'PSDNorm or PSD']);
set(handles.txtPlotLimits,'ToolTipString',...
	'Suggested: within Min and Max of data');

% Assign function output
fig_hdl = handles.figPlotData;

% Setting of radio buttons
set(handles.radioImage,'Min',0,'Max',1,'Value',valRadioPlotAs(1));
set(handles.radioContourPlot,'Min',0,'Max',1,'Value',valRadioPlotAs(2));
% Setting of check box
set(handles.checkLogAxis3,'Min',0,'Max',1,'Value',valCheckLogAxis3);
% Scale size to fit the text in
%objFieldnames=fieldnames(handles);
%for ii=1:length(objFieldnames),
%	curPos=get(handles.(objFieldnames{ii}),'Position');
%	newPos=curPos*scalingFact;
%	set(handles.(objFieldnames{ii}),'Position',newPos);
%end;
% Move gui to center, make visible
movegui(fig_hdl,'center');
set(fig_hdl,'visible','on');

else
figure(fig_hdl);
end;

%-------------------------------------------------------------------------------
	function pushClose_Callback(hObject,evendata)
		hndl=findobj('tag',nameFigPlot);
		if ~isempty(hndl),
			close(hndl);
		end;
		set(hndMainGUI,'Visible','On');
		close(fig_hdl);
	end

%-------------------------------------------------------------------------------
	function pushPlot_Callback(hObject,evendata)
		% get global and persistent vars
		MSpScn=getPopCurStr(handles.popDatasetToHandlePlot);
		strMinPlot=get(handles.editPlotMin,'String');
		strMaxPlot=get(handles.editPlotMax,'String');
		
		cmd=['cscn=',MSpScn,';'];
		eval(cmd);
		strAx1Field=getPopCurStr(handles.popAxis1);
		strAx2Field=getPopCurStr(handles.popAxis2);
		strAx3Field=getPopCurStr(handles.popAxis3);
		minPlot=getNumEdit(handles.editPlotMin);
		maxPlot=getNumEdit(handles.editPlotMax);
	
		if (valCheckLogAxis3==1),
			if (minPlot<=0 || maxPlot<=0),
			 warndlg(['Axis limits must be >0 for log scaling of 3rd axis.'],...
				'Bad Input','modal');
			 return
			end
			cdat=cscn.(strAx3Field);
			ind=find(cdat<minPlot);
			cdat(ind)=minPlot;
			ind=find(cdat>maxPlot);
			cdat(ind)=maxPlot;
			cdat=log10(cdat);
		else
			cdat=cscn.(strAx3Field);
			ind=find(cdat<minPlot);
			cdat(ind)=minPlot;
			ind=find(cdat>maxPlot);
			cdat(ind)=maxPlot;
		end;

		hfig=findobj('tag',nameFigPlot);
		if isempty(hfig),
			hfig=figure;
			set(hfig,'tag',nameFigPlot,'Name','MatSpec: Plotted data',...
				'PaperUnits', 'normalized',...
				'PaperType', 'A4','PaperPosition', [.09 .29 .65 .42],...
				'DefaultAxesFontUnits', 'points','DefaultAxesFontSize', ...
				defAxFontSize, 'DefaultAxesLineWidth', 1.5,...
				'DefaultAxesPosition',[.16 .15 .73 .73],...
				'DefaultLineLineWidth', 1,...
				'DefaultTextFontUnits', 'points',...
				'DefaultTextFontSize', defTxtFontSize);
		else
			figure(hfig);
		end;
		delete(get(hfig,'children'));
		if (valRadioPlotAs(1)==1),
			imagesc(cscn.(strAx1Field),cscn.(strAx2Field),...
				cdat); axis xy;
		elseif (valRadioPlotAs(2)==1),
			contourf(cscn.(strAx1Field),cscn.(strAx2Field),...
				cdat); 
		end;
		xlabel(strLabelAxis1);
		ylabel(strLabelAxis2);
		hColBar=colorbar;
		set(get(hColBar,'ylabel'),'string',...
			strLabelAxis3,'fontsize',defTxtFontSize);
	end

%-------------------------------------------------------------------------------
	function pushSave_Callback(hObject,evendata),
		hndl=findobj('tag',nameFigPlot);
		if isempty(hndl),
			warndlg('Data are not yet plotted. Plot first, please.');
			return;
		else
			figure(hndl);
		end;
		fileformat=getPopCurStr(handles.popFileFormat);
		valPopFileFormat=get(handles.popFileFormat,'Value');

		[filename,currDir]=uiputfile({['*.',fileformat];['*.*']},'Save As',...
			[currDir,MSpScn,'.',fileformat]);
		if isequal(filename,0) | isequal(currDir,0)
			 errordlg('User selected Cancel','Save As Canceled','Modal')
			 return;
		end
		print(hndl,PrintFormats{valPopFileFormat,2},...
			fullfile(currDir,filename));
	end

	
%-------------------------------------------------------------------------------
	function BtnGroupPlotAs_selChangFcn(hObject,eventdata),
		switch get(eventdata.NewValue,'Tag'),
		case 'radioImage',
			valRadioPlotAs=[1,0];
		case 'radioContourPlot',
			valRadioPlotAs=[0,1];
		end;
	end;

%-------------------------------------------------------------------------------
	function checkLogAxis3_Callback(hObject,evendata)
		valCheckLogAxis3=get(handles.checkLogAxis3,'Value');
	end

%-------------------------------------------------------------------------------
	function editLabelAxis1_Callback(hObject,evendata)
		strLabelAxis1=get(handles.editLabelAxis1,'String');
	end

%-------------------------------------------------------------------------------
	function editLabelAxis1_CreateFcn(hObject,evendata)
		set(hObject,'String',strLabelAxis1);
	end

%-------------------------------------------------------------------------------
	function editLabelAxis2_Callback(hObject,evendata)
		strLabelAxis2=get(handles.editLabelAxis2,'String');
	end

%-------------------------------------------------------------------------------
	function editLabelAxis2_CreateFcn(hObject,evendata)
		set(hObject,'String',strLabelAxis2);
	end

%-------------------------------------------------------------------------------
	function editLabelAxis3_Callback(hObject,evendata)
		strLabelAxis3=get(handles.editLabelAxis3,'String');
	end

%-------------------------------------------------------------------------------
	function editLabelAxis3_CreateFcn(hObject,evendata)
		set(hObject,'String',strLabelAxis3);
	end

%-------------------------------------------------------------------------------
	function editPlotMin_Callback(hObject,evendata)
		strMinPlot=get(handles.editPlotMin,'String');
	end

%-------------------------------------------------------------------------------
	function editPlotMin_CreateFcn(hObject,evendata)
		set(hObject,'String',strMinPlot);
	end

%-------------------------------------------------------------------------------
	function editPlotMax_Callback(hObject,evendata)
		strMaxPlot=get(handles.editPlotMax,'String');
	end

%-------------------------------------------------------------------------------
	function editPlotMax_CreateFcn(hObject,evendata)
		set(hObject,'String',strMaxPlot);
	end

%-------------------------------------------------------------------------------
	function popDatasetToHandlePlot_Callback(hObject,evendata)
		MSpScn=getPopCurStr(handles.popDatasetToHandlePlot);
		myFieldNames=retrieveDataFields;
		setPopFieldNames(handles.popAxis1,myFieldNames,valPopAxis1);
		setPopFieldNames(handles.popAxis2,myFieldNames,valPopAxis2);
		setPopFieldNames(handles.popAxis3,myFieldNames,valPopAxis3);
		cMax=getDataExtreme(1);
		if ~isempty(cMax),
			set(handles.txtMaxData,'String',num2str(cMax,'%8.2e'));
		else
			set(handles.txtMaxData,'String','1');
		end;
		cMin=getDataExtreme(0);
		if ~isempty(cMin),
			set(handles.txtMinData,'String',num2str(cMin,'%8.2e'));
		else
			set(handles.txtMinData,'String','0.1');
		end;
	end

%-------------------------------------------------------------------------------
	function popDatasetToHandlePlot_CreateFcn(hObject,evendata)
		if (~isempty(MSpScn) && ~isempty(MSpScnList)),
				ii=find(strcmp(MSpScn,MSpScnList),1);
				set(hObject,'String',MSpScnList,'Value', ii);
		elseif length(MSpScnList)>0,
				set(hObject,'String',MSpScnList,'Value', 1);
		else
				set(hObject,'String',{'------'});
		end;
	end

%-------------------------------------------------------------------------------
	function popAxis1_Callback(hObject,evendata)
		valPopAxis1=get(handles.popAxis1,'Value');
	end
%-------------------------------------------------------------------------------
	function popAxis1_ButtonDownFcn(hObject,evendata),
		valPopAxis1=get(handles.popAxis1,'Value');
	end;

%-------------------------------------------------------------------------------
	function popAxis1_CreateFcn(hObject,evendata)
		myFieldNames=retrieveDataFields;
		valPopAxis1=setPopFieldNames(hObject,myFieldNames,valPopAxis1);
	end

%-------------------------------------------------------------------------------
	function popAxis2_Callback(hObject,evendata)
		valPopAxis2=get(handles.popAxis2,'Value');
	end

%-------------------------------------------------------------------------------
	function popAxis2_CreateFcn(hObject,evendata)
		myFieldNames=retrieveDataFields;
		valPopAxis2=setPopFieldNames(hObject,myFieldNames,valPopAxis2);
	end

%-------------------------------------------------------------------------------
	function popAxis3_Callback(hObject,evendata)
		valPopAxis3=get(handles.popAxis3,'Value');
		cMax=getDataExtreme(1);
		if ~isempty(cMax),
			set(handles.txtMaxData,'String',num2str(cMax,'%8.2e'));
		else
			set(handles.txtMaxData,'String','1');
		end;
		cMin=getDataExtreme(0);
		if ~isempty(cMin),
			set(handles.txtMinData,'String',num2str(cMin,'%8.2e'));
		else
			set(handles.txtMinData,'String','0.1');
		end;
	end

%-------------------------------------------------------------------------------
	function popAxis3_CreateFcn(hObject,evendata)
		myFieldNames=retrieveDataFields;
		valPopAxis3=setPopFieldNames(hObject,myFieldNames,valPopAxis3);
	end

%-------------------------------------------------------------------------------
	function popFileFormat_Callback(hObject,evendata)
		valPopFileFormat=get(handles.popFileFormat,'Value');
	end

%-------------------------------------------------------------------------------
	function popFileFormat_CreateFcn(hObject,evendata)
		set(hObject,'String',PrintFormats(:,1));
		valPopFileFormat=setPopFieldNames(hObject,PrintFormats(:,1),...
			valPopFileFormat);
	end

%-------------------------------------------------------------------------------
	function txtMaxData_CreateFcn(hObject,evendata),
		cMax=getDataExtreme(1);
		if ~isempty(cMax),
			set(hObject,'String',num2str(cMax,'%8.2e'));
		else
			set(hObject,'String','1');
		end;
	end;
%-------------------------------------------------------------------------------
	function txtMinData_CreateFcn(hObject,evendata),
		cMin=getDataExtreme(0);
		if ~isempty(cMin),
			set(hObject,'String',num2str(cMin,'%8.2e'));
		else
			set(hObject,'String','0.1');
		end;
	end;
%-------------------------------------------------------------------------------
function closeIt(gcbf,ar2);
set(hndMainGUI,'Visible','On');
delete(fig_hdl);
end;
%-------------------------------------------------------------------------------
	function res=getDataExtreme(flgMinMax),
		% returns minima or maxima of current data on 3rd axis
		% flgMinMax=0 ... minima
		% flgMinMax=1 ... maxima
		cDataset=getPopCurStr(handles.popDatasetToHandlePlot);
		cAxis3=getPopCurStr(handles.popAxis3);
		cdat=0;
		res=[];

		if exist(cDataset),
			myFieldNames=retrieveDataFields;
			if any(strcmp(cAxis3,myFieldNames)),
				cmd=['cdat=',cDataset,'.',cAxis3,';'];
				eval(cmd);
				if isnumeric(cdat),
					if flgMinMax==1,
						res=max(max(cdat));
					else
						res=min(min(cdat));
					end;
				end;
			end;
		end;
	end;




	function myFieldNames=retrieveDataFields;
		% retrieve fields of the dataset
		myFieldNames={};
		flgIsStruct=0;
		if ~isempty(MSpScn),
				if  iscell(MSpScn),
						MSpScn=MSpScn{1};
				end;
				cmd=['flgIsStruct=isstruct(', MSpScn,');'];
				eval(cmd);
				if flgIsStruct,
						cmd=['myFieldNames=fieldnames(',MSpScn,');'];
						eval(cmd);
				else
						myFieldNames={};
				end;
		else,
				myFieldNames={};
		end;
	end;

	function str=getPopCurStr(hndl),
		strs=get(hndl,'String');
		ii=get(hndl,'Value');
		str=strs{ii};
	end;
	function val1=setPopFieldNames( hndl, str, val),
		% Set popup menu field names and the current filed (val)
		% hndl ... handle to the popup menu
		% str ... string
		% val ... value
		if (isempty(str)),
			lstr=1;
			str={'------'};
		else if (iscell(str)),
			lstr=length(str);
		else
			lstr=1;
		end;
		end;

		if (val>lstr),
			val=1;
		end;
		
		set(hndl,'String',str);
		set(hndl,'Value',val);
		val1=val;
	end;

	function num=getNumEdit(hndl),
		mstr=get(hndl,'String');
		num=str2double(mstr);
		if isnan(num)
		 errordlg([mstr, ' is not a numeric value.'],...
		 	'Bad Input','modal');
		 return
		end
	end;
end
