function fig_hdl = SaveToMatFile
% MatSpec GUI
% J. Novak, 08-11-12
% build: generate_m_file('SaveToMatFile.fig','../')
% SAVETOMATFILE_BUILD
%-------------------------------------------------------------------------------
% File name   : SaveToMatFile_build.m         
% Generated on: 12-Nov-2008 16:45:22          
% Description :
%-------------------------------------------------------------------------------


% --- VARIABLES ----------------------------------
global MSpScnList MSpf  MSpScn;
persistent valPopDatasetToSave valPopOutputFormat
persistent currDir
if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
			cmd=['global ', MSpScnList{ii}];
			eval(cmd);
	end;
end;
if isempty(valPopDatasetToSave),
	valPopDatasetToSave=1;
end;
if isempty(valPopOutputFormat),
	valPopOutputFormat=1;
end;
MlbVersion=version;
ind=findstr('.',MlbVersion);
ind=ind(2);
if (str2double(MlbVersion(1:ind-1))>=7.3),
	OutputFormats={'Standard Mat-file','';'HDF5','-v7.3'};
else
	OutputFormats={'Standard Mat-file',''};
end;
if isempty(currDir),
	currDir='./';
end;
fig_hdl=findobj('tag','figSaveToMatFile');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');
if isempty(fig_hdl),
% --- FIGURE -------------------------------------
handles.figSaveToMatFile = figure(	'Tag', 'figSaveToMatFile', ...
	'Units', 'characters', ...
	'Position', [103.8 48.6 52.8 12.8], ...
	'Name', 'MatSpec: Save To Mat-file', ...
	'MenuBar', 'none', ...
	'Visible','Off',...
	'NumberTitle', 'off', ...
	'CloseRequestFcn',{@closeIt},...
	'Color', get(0,'DefaultUicontrolBackgroundColor'));

% Scale factor to accomodate figure for the system specific graphical properties
%htmp=uicontrol('Style','text','units','pixels',...
%	'fontunits','pixels','position',[10 10 20 10],...
%	'fontsize',10,'string','jg');
%curH=get(htmp,'Extent');
%scalingFact=curH(4)/get(htmp,'fontsize')*.8;
%delete(htmp);
% --- STATIC TEXTS -------------------------------------
handles.txtDatasetToSave = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'txtDatasetToSave', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [1.8 7.8 21.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Data-set to be saved');

handles.txtOutputFormat = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'txtOutputFormat', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [1.8 4.9 21.5 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Output format');

handles.txtTitleSaveToMatFile = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'txtTitleSaveToMatFile', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'characters', ...
	'Position', [11 10.5 33.5 2.0], ...
	'FontName', 'Helvetica', ...
	'FontSize', 18, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Save to Mat-file');

% --- PUSHBUTTONS -------------------------------------
handles.pushSaveSaveToMatFile = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'pushSaveSaveToMatFile', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [6 0.8 15.1 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Save', ...
	'Callback', @pushSaveSaveToMatFile_Callback);

handles.pushCloseSaveToMatFile = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'pushCloseSaveToMatFile', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'characters', ...
	'Position', [29.8 0.9 13.5 1.9], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'FontWeight', 'bold', ...
	'String', 'Close', ...
	'Callback', @pushCloseSaveToMatFile_Callback);

% --- POPUP MENU -------------------------------------
handles.popDatasetToSave = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'popDatasetToSave', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [24.5 7.8 25.6 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '---------', ...
	'Callback', @popDatasetToSave_Callback, ...
	'CreateFcn', @popDatasetToSave_CreateFcn);

handles.popOutputFormat = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'popOutputFormat', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'characters', ...
	'Position', [24.5 4.9 25.6 1.7], ...
	'FontName', 'Helvetica', ...
	'FontSize', 12, ...
	'String', '---------', ...
	'Callback', @popOutputFormat_Callback, ...
	'CreateFcn', @popOutputFormat_CreateFcn);

% Save handles structure
guidata(handles.figSaveToMatFile,handles);
% Scale size to fit the text in
%objFieldnames=fieldnames(handles);
%for ii=1:length(objFieldnames),
%	curPos=get(handles.(objFieldnames{ii}),'Position');
%	newPos=curPos*scalingFact;
%	set(handles.(objFieldnames{ii}),'Position',newPos);
%end;

% Assign function output
fig_hdl = handles.figSaveToMatFile;

movegui(fig_hdl,'center');
set(fig_hdl,'visible','on');
else
figure(fig_hdl);
end;

%-------------------------------------------------------------------------------
	function pushSaveSaveToMatFile_Callback(hObject,evendata),
		SaveOpt=OutputFormats{valPopOutputFormat,2};
		[filename,currDir]=uiputfile({'*.mat';'*.hdf'},'Save As',...
			[currDir,MSpScn,'.mat']);
		if isequal(filename,0) | isequal(currDir,0)
			 errordlg('User selected Cancel','Save As Canceled','Modal')
			 return;
		end
		ffname=fullfile(currDir,filename);
		save(ffname,MSpScn,SaveOpt);
		msgbox(sprintf('Data-set %s was saved to the file %s',MSpScn,...
			ffname),'MatSpec: Data-set saved');	
	end

%-------------------------------------------------------------------------------
	function pushCloseSaveToMatFile_Callback(hObject,evendata)
		set(hndMainGUI,'Visible','On');
		close(fig_hdl);
	end

%-------------------------------------------------------------------------------
	function popDatasetToSave_Callback(hObject,evendata)
		MSpScn=getPopCurStr(handles.popDatasetToSave);
	end

%-------------------------------------------------------------------------------
	function popDatasetToSave_CreateFcn(hObject,evendata)
		if (~isempty(MSpScn) && ~isempty(MSpScnList)),
				ii=find(strcmp(MSpScn,MSpScnList),1);
				set(hObject,'String',MSpScnList,'Value', ii);
		elseif length(MSpScnList)>0,
				set(handles.popDatasetToHandlePlot,'String',MSpScnList,'Value', 1);
		else
				set(hObject,'String',{'------'});
		end;
	end

%-------------------------------------------------------------------------------
	function popOutputFormat_Callback(hObject,evendata)
		valPopOutputFormat=get(handles.popOutputFormat,'Value');
	end

%-------------------------------------------------------------------------------
	function popOutputFormat_CreateFcn(hObject,evendata)
		set(hObject,'String',OutputFormats(:,1),'Value',valPopOutputFormat);
	end
%-------------------------------------------------------------------------------
function closeIt(gcbf,ar2);
set(hndMainGUI,'Visible','On');
delete(fig_hdl);
end;
%-------------------------------------------------------------------------------
	function myFieldNames=retrieveDataFields;
		% retrieve fields of the dataset
		myFieldNames={};
		flgIsStruct=0;
		if ~isempty(MSpScn),
				if  iscell(MSpScn),
						MSpScn=MSpScn{1};
				end;
				cmd=['flgIsStruct=isstruct(', MSpScn,');'];
				eval(cmd);
				if flgIsStruct,
						cmd=['myFieldNames=fieldnames(',MSpScn,');'];
						eval(cmd);
				else
						myFieldNames={};
				end;
		else,
				myFieldNames={};
		end;
	end;

	function str=getPopCurStr(hndl),
		strs=get(hndl,'String');
		ii=get(hndl,'Value');
		str=strs{ii};
	end;
	function val1=setPopFieldNames( hndl, str, val),
		% Set popup menu field names and the current filed (val)
		% hndl ... handle to the popup menu
		% str ... string
		% val ... value
		if (isempty(str)),
			lstr=1;
			str={'------'};
		else if (iscell(str)),
			lstr=length(str);
		else
			lstr=1;
		end;
		end;

		if (val>lstr),
			val=1;
		end;
		
		set(hndl,'String',str);
		set(hndl,'Value',val);
		val1=val;
	end;


end
