%Transform2QSpace.m
 
function Transform2QSpace

%% Initialization
global MSpScnList  MSpf  MSpScn
% global for this menu
global funcName ArgList text2display
% Config file name
persistent ConfigFName
ConfigFName='Ang2Q.cfg';


% Make datasets known here
if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
		cmd=['global ', MSpScnList{ii}];
		eval(cmd);
	end;
end;
 
%normally read from file 'Ang2A.cfg'
[funcName,ArgList,text2display]=MSpGUIReadQPlotCfg(ConfigFName);
 
if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
			cmd=['global ', MSpScnList{ii}];
			eval(cmd);
	end;
end;

 
f0=figure('Visible','off',...
	'MenuBar', 'none', ...
'Position',[20,20,520,500]);
set(f0,'Name','Transform to Q-Space');
set(f0,'tag','TransformToQSpace');
set(f0,'Visible','off',...
	'CloseRequestFcn',{@closeIt});
hndMainGUI=findobj('Tag','figGUIMatSpec');
movegui(f0,'center');
set(hndMainGUI,'visible','off');

%TRANSFORM TO Q-SPACE
hlbPlotRoughData = uicontrol('Style','text','FontSize',18,...
	'String','Transform to Q-space',...
	'FontWeight', 'Bold','Position',[110,470,300,25],...
	'TooltipString',['Transforms angular coordinates to ',...
		'reciprocal-space coordinates for a given dataset.']...
	);
	
txtDataSet2Handle=uicontrol('Style','text',...
	'Position',[20,440,200,20],...
	'FontSize',12,...
	'String','Dataset to be handled');
hpopDataSet2BeTransformed=uicontrol('Style',...
	'popupmenu',...
	'Position',[220,440,80,20],...
	'Callback',{@popDataSet2BeTransformed_Callback});

if (~isempty(MSpScn) && ~isempty(MSpScnList)),
    ii=find(strcmp(MSpScn,MSpScnList),1);
    set(hpopDataSet2BeTransformed,'String',MSpScnList,'Value', ii);
elseif length(MSpScnList)>0,
    set(hpopDataSet2BeTransformed,'String',MSpScnList,'Value', 1);
else
    set(hpopDataSet2BeTransformed,'String','---');
end;

% Retrive fields of the dataset
flgIsStruct=0;
if ~isempty(MSpScn),
    if  iscell(MSpScn),
        MSpScn=MSpScn{1};
    end;
    cmd=['flgIsStruct=isstruct(', MSpScn,');'];
    eval(cmd);
    if flgIsStruct,
        cmd=['myFieldNames=fieldnames(',MSpScn,');'];
        eval(cmd);
    else
        myFieldNames={}
    end;
else,
    myFieldNames={}
end;

%TRANSFORMATION FUNCTION
global CurrentFuncName;
if isempty(CurrentFuncName),
	if ~isempty(funcName),
		CurrentFuncName=funcName{1};
	else,
		CurrentFuncName='---';
	end;
end;
hlbTransformationfunction = uicontrol('Style','text','String',...
	'Transformation function:','Position',[20,400,200,20]);
hedTransformationfunction = uicontrol('Style','edit','String',...
	CurrentFuncName,'Position',[220,400,120,20]);
hpbTransformationfunction = uicontrol('Style','pushbutton','String', ...
	'TRANSFORM','Position',[400,400,100,20],'Callback',...
	{@pbTransformationfunction_Callback});



%ARGUMENTS TRANSFORMATION FUNCTION
global CurrentArgList;
if isempty(CurrentArgList),
	if ~isempty(ArgList),
		CurrentArgList=ArgList{1};
	else,
		CurrentArgList={};
	end;
end;

lbargs={'Arguments','of the', 'transfromation', 'function'};
hlbArgTransFunc = uicontrol('Style','text','String',lbargs,'Position',[20,300,100,80]);

hlbArg2Add = uicontrol('Style','text','String','Arg to Add:','Position',[20,270,100,20]);

hlistbArgTransFunct=uicontrol('Style','listbox','String',...
	CurrentArgList,'Position', ...
	[120,300,100,80]);%'callback',{@listbArgTransFunct_Callback});


persistent valArg2Add;
if isempty( valArg2Add),
	valArg2Add=1;
end;
% retrive fields of the dataset
flgIsStruct=0;
if ~isempty(MSpScn),
    if  iscell(MSpScn),
        MSpScn=MSpScn{1};
    end;
    cmd=['flgIsStruct=isstruct(', MSpScn,');'];
    eval(cmd);
    if flgIsStruct,
        cmd=['myFieldNames=fieldnames(',MSpScn,');'];
        eval(cmd);
    else
        myFieldNames={}
    end;
else,
    myFieldNames={}
end;

hpopArg2Add= uicontrol('Style','popup','String',myFieldNames,...
	'Position',[120,270,100,20],'Callback',{@popArgTransFunct_Callback});
set( hpopArg2Add, 'val', valArg2Add);

hpbArgsAdd =uicontrol('Style','pushbutton','String','Add','Position',...
	[20,240,100,20],'Callback',{@pbArgsAdd_Callback});
hpbArgsRemove =uicontrol('Style','pushbutton','String','Remove',...
	'Position',[120,240,100,20],'Callback',{@pbArgsRemove_Callback});

% Current comments
global CurrentComment;
if isempty(CurrentComment),
	if ~isempty(text2display),
		CurrentComment=text2display{1};
	else,
		CurrentComment='---';
	end;
end;
hlbComments2Save = uicontrol('Style','edit','String',...
	CurrentComment,'Position',[230,240,270,110],'Max',2);



hlbComments = uicontrol('Style','text','String',...
	'Comments to save:','Position',[230,360,170,20]);
hpbSaveCfg = uicontrol('Style','pushbutton','String','Save cfg.',...
	'Position',[420,360,80,20],'Callback',{@pbSaveCfg_Callback});

%LOAD FUNCTION NAME + ARGUMENTS FORM CONFIGURATION FILE
hfrLoadFunctionName = uicontrol('Style',...
	'frame','Position',[20,20,480,200]);
hlbLoadFunctionNameTitle = uicontrol('Style','text','String',...
	' Load function name + arguments from configuration file: ',...
	'FontSize',10,'Position',[30,190,440,20]);

%set(hedTransformationfunction,'String',funcName{1});
hpopTransformationFunction =uicontrol('Style','popupmenu',...
	'String',funcName,...
	'Position',[390,90,100,20],'Callback',...
	{@popTransformationFunction_Callback});

hlbLoadFunctionName = uicontrol('Style','edit','String',...
	text2display{1},'BackgroundColor','white','Position',...
	[30,30,350,150],'max',2);
hpbLoad = uicontrol('Style','pushbutton','String',{'LOAD'},...
	'Position',[390,60,100,20],'Callback',{@pbLoad_Callback});
set(f0,'Visible','on');

function pbArgsRemove_Callback(hObject,eventdata)
    str22=get(hlistbArgTransFunct,'String');
    val=get(hlistbArgTransFunct,'Value');
    disp(str22);
    disp(val);
    str22(val)=[];
    disp(str22);
    set(hlistbArgTransFunct,'String',str22);
    set(hlistbArgTransFunct,'Value',1);

end

function pbArgsAdd_Callback(hObject,eventdata)
    
	strr=get(hlistbArgTransFunct,'String');
	val1=get(hlistbArgTransFunct,'Value');
	n=length(strr);
	disp(val1);
	disp(n);
	disp(strr);
    
	str22=get(hpopArg2Add,'String');
	val2=get(hpopArg2Add,'Value');
	str2add=str22{val2};
% strr{n+1}=str2add;
	strr={strr{1:val1},strr{val1:n}};
	strr{val1}=str2add;
	disp(strr);
	set(hlistbArgTransFunct,'String',strr);
end

function pbTransformationfunction_Callback(hObject,eventdata)
	% collect function name + arguments
	str=get(hpopDataSet2BeTransformed,'String');
	val=get(hpopDataSet2BeTransformed,'Value');
	MSpScn=str{val};
	CurrentFuncName=get(hedTransformationfunction,'string');
	CurrentArgList=get(hlistbArgTransFunct,'string');
	% create command structure
	Ang2Q={CurrentFuncName,CurrentArgList{:}};
	flgUnspec=0;
	flgNormalize=0;
	flgAng2Q=1;
	flgPlotPSD=0;
	flgAutoGridEst=0;
	flgGridQ=0;
	flgPlotGrid=0;
	flgPrintPlot=0;
	flgSaveMat=0;
	flgLoadMat=0;
	flgSaveAscii=0;
	MSpMain2;
	hThisFig=findobj('tag','TransformToQSpace');
	set(hndMainGUI,'Visible','On');
	msgbox(['Qx,Qy,Qz were calculated and added to dataset ',...
	MSpScn,'.']);
	close(hThisFig);
end

function popTransformationFunction_Callback(hObject,eventdata)
    
  str0=get(hpopTransformationFunction,'String');
	val=get(hpopTransformationFunction,'Value');
	set( hlbLoadFunctionName,'String',text2display{val});
end

function popArgTransFunct_Callback(hObject,eventdata),
	valArg2Add=get( hpopArg2Add, 'val');
end;

function pbLoad_Callback(hObject,eventdata)
	strs=get(hpopTransformationFunction,'String');
	val=get(hpopTransformationFunction,'value');
	CurrentFuncName=strs{val};
	set(hedTransformationfunction,'string',CurrentFuncName);
	CurrentArgList=ArgList{val};
	set(hlistbArgTransFunct,'string',CurrentArgList);
	CurrentComment=text2display{val};
	set(hlbComments2Save,'string',CurrentComment);
end

function pbSaveCfg_Callback(hObject,eventdata),
	CurrentFuncName=get(hedTransformationfunction,'string');
	CurrentArgList=get(hlistbArgTransFunct,'string');
	CurrentComment=get(hlbComments2Save,'string');
	CurrentComment=cellstr(CurrentComment);
	MSpGUIWriteQPlotCfg(ConfigFName,CurrentFuncName,...
		CurrentArgList,CurrentComment);
	msgbox(sprintf(['Transformation function ', ...
		'parameters were saved to %s'], which(ConfigFName)));
end;

function closeIt(source, eventdata),
		set(hndMainGUI,'Visible','On');
		delete(f0);
end;

end


 
 

